#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
#  : " Unicode  Perl"
# :      ( )
# :      . .
# :      18.12.2013
# :    0.1
# -----------------------------------------------------------------------------

#         
use strict;

use utf8;
use Unicode::Collate;

my $file = "text.txt";

#          UTF-8
binmode STDOUT, ':utf8';
binmode STDERR, ':utf8';

my @letters = ();
my $abc = "                                ";

@letters = split( /\s+/, $abc );

#      .   "".
foreach my $letter ( sort( @letters ) )
{
  print "$letter ";
}

print "\n";

#  .   "".
foreach my $letter ( Unicode::Collate->new->sort( @letters ) )
{
  print "$letter ";
}

print "\n\n";

$abc = "                                ";

@letters = split( /\s+/, $abc );

#      .   "".
foreach my $letter ( sort( @letters ) )
{
  print "$letter ";
}

print "\n";

#  .   "".
foreach my $letter ( Unicode::Collate->new->sort( @letters ) )
{
  print "$letter ";
}

print "\n\n";


#  "<:encoding(UTF-8)"   
#  ,   ,     UTF-8
open( READ, "<:encoding(UTF-8)", "$file" ) || 
  die "    $file: $!";

#     .    ?
#open( READ, "<", "$file" ) || 
#  die "    $file: $!";

my( $begin, $end );

while ( my $str = <READ> )
{
  chomp $str;

  #        
  print "$str\n";

  #       
  @letters = split( //, $str );

  print "  " . scalar @letters . " ()\n";
  
  #     (  )
  foreach my $letter ( @letters )
  {
    print "$letter ";
  }
  print "\n";
  
  #       
  print " : " . uc( $str ) . "\n";
  print " : " . lc( $str ) . "\n";

  #        --  
  #  ,     --   
  ( $begin, $end ) = $str =~ /^(...)(.*)$/;

  print ": $begin\n";
  print ": $end\n";

  #   ,     ,  
  print '-' x 50 . "\n";
}

close( READ );

exit( 0 );
