#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
# :   ,    
# :  . .
# : 3.10.2014
# -----------------------------------------------------------------------------

#   --   "how long till birthday".

#          ,
# : 
# ./hltbd.pl 26-06-1967

use strict;

my $birthday = $ARGV[ 0 ];

my $today_day;       #  
my $today_month;     #  
my $today_year;      #  

my $birthday_day;    # ( ) 
my $birthday_month;  #  
my $birthday_year;   #   (  )

my $i;
my @days_in_months = ( 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 );

#  0   "" ,    
#        ,     1
my @days_in_two_years = ( 0 );
my $days_till_birthday = 0;

#    
( $today_day, $today_month, $today_year ) = ( localtime() )[ 3..5 ];
$today_month += 1;   # .   localtime()
$today_year += 1900; # .   localtime()

print " $today_day-$today_month-$today_year\n";

( $birthday_day, $birthday_month, $birthday_year ) = 
  $birthday =~ m#^(\d{1,2})[-\./](\d{1,2})[-\./](\d{4})$#;

# DEBUG
# print "$birthday_day, $birthday_month, $birthday_year\n";
# print "$today_day, $today_month, $today_year\n";

#  ,         
# (  )
push( @days_in_two_years, @days_in_months, @days_in_months );

#DEBUG
# print join( ',', @days_in_two_years ) . "\n";

#   ,      
# (        )
$days_in_two_years[ 2 ] = 29 if ( is_leap_year( $today_year ) );
$days_in_two_years[ 14 ] = 29 if ( is_leap_year( $today_year + 1 ) );

#   
if ( $birthday_month == $today_month && $birthday_day == $today_day )
{
  $days_till_birthday = 0;
}

#  ( + )    ( + ),
#       
else
{
  if ( ( $birthday_month > $today_month ) ||
          ( $birthday_month == $today_month && $birthday_day > $today_day )
        )
  {
    ;  #   
  }
  #  ( + )    ( + ),
  #       , ..      
  else
  {
    #      12, ..    
    # (   ,     , 
    #     )
    $birthday_month += 12;
  }

  #       ,   ,  
  #   ,   ,    
  # 
  for ( $i = $today_month; $i <= $birthday_month; $i++ )
  {
    $days_till_birthday += $days_in_two_years[ $i ];
  }

  #      ,  ...
   
  #  ,      
  $days_till_birthday = $days_till_birthday - $today_day;
  
  #  ,    ( )   
  #  
  $days_till_birthday = $days_till_birthday - 
    ( $days_in_two_years[ $birthday_month ] - $birthday_day );
}

if ( $days_till_birthday == 0 )
{
  print "  \n";
}
else
{
  print "    $days_till_birthday  (, )\n";
}

exit( 0 );


sub is_leap_year
{
  my $year = shift;
  
  my $leap = 0;
  
  #  !!!
  if ( $year % 4 == 0 )
  {
    $leap = 1;
  }

  return $leap;
}
