#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
# Группа программ: "Использование Unicode в Perl"
# Программа: работа со строками русскоязычных символов
# Автор:     Моргунов Е. П.
# Дата:      18.12.2013
# Версия:    0.1
# -----------------------------------------------------------------------------

# эта строка означает строгую проверку синтаксиса исходного текста программы
use strict;

# Закомментируйте команды "use utf8;" и "binmode STDOUT..." поочередно, 
# а потом обе вместе. Что получается на выходе программы?

# эта директива означает, что ИСХОДНЫЙ ТЕКСТ скрипта представлен в Unicode
use utf8;

# Раскомментируйте эту директиву, а "use utf8" закомментируйте. Что получается?
#use feature 'unicode_strings';

# Назначим вывод в кодировке UTF-8 для устройства STDOUT 
# Попробуйте закомментировать эту команду. Будет выведено предупреждение
# "Wide character ..."
binmode STDOUT, ':encoding(UTF-8)'; # можно сделать и так (хотя эти два метода 
                                    # НЕ ТОЖДЕСТВЕННЫ): binmode STDOUT, ':utf8';
my $string = "Россия";

print "$string\n";

print "Первые три символа: " . substr( $string, 0, 3 ) . "\n";

exit 0;
