#!perl -w

use strict;
my $author;

my @authors = ( 'Тургенев', 'Пушкин', 'Толстой' );

print "Вывод всего массива\n";

for ( my $i = 0; $i <= $#authors; $i++ )
{
  print "Элемент массива номер $i равен: $authors[ $i ]\n";
}

print "\nПоиск элемента в массиве\n";

for ( my $i = 0; $i <= $#authors; $i++ )
{
  next unless $authors[ $i ] eq 'Пушкин';

  print "Элемент массива номер $i равен: $authors[ $i ]\n";
  last;
}


print "\nВывод всего массива (цикл foreach)\n";

foreach my $author ( @authors )
{
  print "$author\n";
}


print "\nВывод всего массива (цикл foreach с переменной \$_)\n";

foreach ( @authors )
{
  print "$_\n";
}

print "\nВывод всего массива (постусловие: цикл foreach с переменной \$_)\n";

print "$_\n" foreach ( @authors );


exit( 0 );
