/*  6.2  :

    . ,  . '.  . 
    . . : -, 2005.
*/

/*   .  . */

/*
     -pg

  :
  ./sum_arrays num_rows num_cols
  , 
  ./sum_arrays 5000 10000

    (     a.prof)
  
  gprof sum_arrays > a.prof
*/

#include <stdio.h>
#include <stdlib.h>


int sum_array_rows( int **a, int rows, int cols );
int sum_array_cols( int **a, int rows, int cols );


int main( int argc, char **argv )
{
  int i;
  int j;

  int **array;
  
  int rows = atoi( argv[ 1 ] );  /*     */
  int cols = atoi( argv[ 2 ] );  /*      */

  /*     */
  long sum_rows = 0;  /*    */
  long sum_cols = 0;  /*    */
  
  /* C        . */
  array = ( int ** )malloc( rows * sizeof( int * ) );
  
  /*    ... */
  for ( i = 0; i < rows; i++ )
  {
    /* ...  . */
    array[ i ] = ( int * )malloc( cols * sizeof( int ) );
    
    /*        . */
    for ( j = 0; j < cols; j++ )
    {
      array[ i ][ j ] = i;
    }
  }

  /*     . */

  /*    */
  sum_rows = sum_array_rows( array, rows, cols );

  /*    */
  sum_cols = sum_array_cols( array, rows, cols );

  printf( "   = %ld\n", sum_rows );
  printf( "   = %ld\n", sum_cols );

  return 0;
}


int sum_array_rows( int **a, int rows, int cols )
{
  int i;
  int j;
  int sum = 0;

  for ( i = 0; i < rows; i++ )
  {
    for ( j = 0; j < cols; j++ )
    {
      /*     . */
      sum += a[ i ][ j ];
    }
  }

  return sum;
}

int sum_array_cols( int **a, int rows, int cols )
{
  int i;
  int j;
  int sum = 0;
  
  for ( j = 0; j < cols; j++ )
  {
    for ( i = 0; i < rows; i++ )
    {
      /*        , 
             . */
      sum += a[ i ][ j ];
    }
  }

  return sum;
}
