# -----------------------------------------------------------------------------
#  Perl:     
# -----------------------------------------------------------------------------

package Math::Geometry;  #  Math,  Geometry.pm

use strict;
use warnings;

BEGIN
{
  use Exporter   ();
  our ($VERSION, @ISA, @EXPORT, @EXPORT_OK, %EXPORT_TAGS);

  #   
  $VERSION     = 1.00;
  #       
  #    (RCS/CVS)
  $VERSION = sprintf "%d.%03d", q$Revision: 1.1 $ =~ /(\d+)/g;

  @ISA         = qw( Exporter );

  #    (),
  #    
  # .  ,       
  #               : circle_area  circle_len.  
  #              - .
  @EXPORT      = qw( &func1 &func2 &func4 
                     &circle_area &circle_len );
  %EXPORT_TAGS = ();     # : TAG => [ qw!name1 name2! ],

  #     ()
  #  ,     
  # .  ,       
  #                square_perim.  
  #              - .
  @EXPORT_OK   = qw( $Var1 %Hashit &func3
                     &square_perim );
}
our @EXPORT_OK;

#      ()
our $Var1;
our %Hashit;

#      ()
our @more;
our $stuff;

#       ()
$Var1   = '3';
%Hashit = ();

#       ()
# .       , ,
#             $Math::Geometry::stuff,    $stuff.
$stuff  = '4';
@more   = ();

#   ,    
#  ,    ,   ,
#   

#   ,     
my $priv_var    = '2';
my %secret_hash = ();

#   ,     
#    : &$priv_func;
#      
my $priv_func = sub {
    #  
};

#     ,  ,
#   
# .    -  
#               {}.
sub func1      {}    #   
sub func2()    {}    #     
sub func3($$)  {}    #       
sub func4(\%)  {}    #      --
                     #   -

END { }       # ,     
              # ( )


#     
# ========================================

# ----------------------------------------------------------------------------
#       
# ----------------------------------------------------------------------------

use constant   PI => 3.14159265;

# ---------------------------
#   
# ---------------------------
sub circle_area( $$ )
{
  #  -        
  my $rad = shift;
  my $formula = shift;

  my $area;

  #  :  *   
  $area = PI * $rad * $rad;
  
  if ( $formula )
  {
    print "    : \n" .
          "---  *    ---\n";
  }
  
  return ( $area );  #  : return ( PI * $rad * $rad );
}

# -------------------------------
#   
# -------------------------------
sub circle_len( $$ )
{
  #  -        
  my $rad = shift;
  my $formula = shift;

  my $len;

  #   : 2 *  * 
  $len = 2 * PI * $rad;

  if ( $formula )
  {
    print "    : \n" .
          "--- 2 *  *  ---\n";
  }
  
  return ( $len );
}


# ----------------------------------------------------------------------------
#     
# ----------------------------------------------------------------------------

# -----------------------------
#   
# -----------------------------
sub square_area( $$ )
{
  #  -        
  my $side = shift;
  my $formula = shift;

  my $area;
  
  #  :    
  $area = $side * $side;

  if ( $formula )
  {
    print "    : \n" .
          "---     ---\n";
  }

  return ( $area );
}

#----------------------------------
#   
# ---------------------------------
sub square_perim( $$ )
{
  #  -        
  my $side = shift;
  my $formula = shift;

  my $len;

  #  : 4 *  
  $len = 4 * $side;

  if ( $formula )
  {
    print "    : \n" .
          "---   * 4 ---\n";
  }

  return ( $len );
}


1;  #    "" (  )
