/*
  : "  "
  :     JavaScript,    
  :   . . 
  :    30.11.2017
  :  0.1
*/

/*
       .
     AJAX,    
            HTML-,
       .
*/
function delete_record( script_name, script_params, row )
{
  // : script_name --  ,   
  //                              ;
  //            script_params --  ,  
  //                             ;
  //            row --      .
  
  //    XMLHttpRequest.
  var xhttp = new XMLHttpRequest();

  //  -   onreadystatechange.
  //        ,    
  //   XMLHttpRequest, . .   
  // web-      .
  xhttp.onreadystatechange = function()
  {
    //         -- 200 (OK)...
    if ( this.readyState == 4 && this.status == 200 )
    {
      try
      {
        //   ,   web-,
        //      JavaScript.    
        //      JSON.
        var server_response = JSON.parse( this.responseText );      
      }
      //  web-   , 
      //  JSON.parse  .   .
      catch ( err )
      {
        //  ,   web-,   .
        //     ,   PostgreSQL.
        display_message( this.responseText );

        // DEBUG
        // if ( typeof server_response != "object" )
        // {
        //   alert( '   JSON' );
        // }
        return;
      }

      //   delete_discipline (.  disciplines_db.php),
      // delete_student (.  students_db.php), delete_exam 
      // (.  progress_db.php)     echo  
      //    JSON-,     rows 
      //   .  JSON-   
      //  web-   .
      if ( server_response.rows == '1' )
      {
        //   DOM,      
        //  ,     row.
        //      .
        var table_row = document.getElementById( row );
        //   parentNode     ,
        // . . .
        table_row.parentNode.removeChild( table_row );

        display_message( "<p class=\"messages\"> </p>\n" );
      }
      else  // server_response.rows == '0'
      {
        display_message( "<p class=\"messages\">  </p>\n" );
      }
    }
  };

  //    web-.  "POST"  
  // ,    .  script_name
  //   ,    web-  
  //    .  true ,   
  // , . .   delete_record   ,
  //  ""     :    
  // web- ,     .
  xhttp.open( "POST", script_name, true );
  xhttp.setRequestHeader( "Content-Type",
                          "application/x-www-form-urlencoded" );

  //     POST. -
  //       ,  
  //  .
  xhttp.send( "operation=delete&" + script_params );
}

/*
      .
*/
function display_message( message )
{
  // : message --  .

  //  .    URL   ,   
  //    .
  var err_win = window.open( "", "", "menubar=no, status=no, titlebar=no, " +
                             "width=800, height=200" );
  err_win.document.open();  //      .

  // "" HTML-   .
  //   "\n" --  ,   --    ,
  //  HTML-,     
  // HTML-  .
  err_win.document.write( "<!DOCTYPE html>\n" );
  err_win.document.write( "<html xmlns=\"http://www.w3.org/1999/xhtml\">\n" );
  err_win.document.write( "<head>\n" );
  err_win.document.write( "  <meta http-equiv=\"Content-Type\" " + 
                          "content=\"text/html; charset=utf-8\" />\n" );
  err_win.document.write( "  <link rel=\"stylesheet\" " +
                          "href=\"university.css\" type=\"text/css\" />\n" );
  err_win.document.write( "</head>\n" );
  err_win.document.write( "<body>\n" );
  err_win.document.write( message ); 
  err_win.document.write( "\n  <div>\n" );
  err_win.document.write( "    <input type=\"button\" value=\"\" " +
                          "onclick=\"self.close()\" />\n" );
  err_win.document.write( "  </div>\n" );
  err_win.document.write( "</body>\n" );
  err_win.document.write( "</html>\n" );

  err_win.document.close(); //   .
}
