<?php
/*
  Система: "Учет успеваемости студентов"
  Модуль:  отображение верхней части HTML-страницы
  Автор:   Е. П. Моргунов
  Дата:    30.11.2017
  Версия:  0.1
*/

echo <<<END
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
  <title>Простая программа на языке PHP</title>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <link rel="stylesheet" href="university.css" type="text/css" />
</head>

<body>

END;

// Если файл head.php был включен из главного файла всей системы
// university.php, то ссылка на главную сраницу не нужна.
// Не нужна эта ссылка и при использовании модуля disciplines.php
// для выбора учебной дисциплины при вводе/коректировке экзаменационной
// оценки.
if ( ! preg_match( "/university.php$/", $_SERVER[ 'SCRIPT_NAME' ] ) &&
     ! ( preg_match( "/disciplines.php$/", $_SERVER[ 'SCRIPT_NAME' ] ) &&
         isset( $_GET[ 'operation' ] ) && $_GET[ 'operation' ] == 'select'
       )
   )
{
  echo "<a href=\"university.php\" target=\"_self\">" .
       "Главная страница</a>\n";
}

echo <<<END
<h1>Система &quot;Учет успеваемости студентов&quot;</h1>
<hr />

END;
?>
