#!/usr/bin/perl -w

# :       " ".
# :      . .
# :      22.10.2016.
# :    0.1.

# TODO. 
# 1.       
#     .
# 2.  ,      
#    .

use strict;

my @operand1 = (); #    
my @operand2 = (); #    
my @result;        #    
my $symbol;        #  ,   

# ,   ,    
#   -.  \&    .
my %operations = ( '+' => \&addition, 
                   '-' => \&subtraction,
                   '*' => \&multiplication,
                   '/' => \&division 
                 );
my $operation;

print " ,    : +, -, *, /\n";
$operation = <STDIN>;
chomp $operation;

#       
# .       . 
# grep()    {...}       
#    ,     {...}  true.
#        0, , 
#      .     
#     if ( @array == 0 ),     
#        ,     .
if ( grep( { $operation eq $_; } ( '+', '-', '*', '/' ) ) == 0 )
{
  print "     \n";
  exit( 1 );
}

#           
#    .
# .        , ..  ,  
#          .       
#           :      
# . ,  256:  2    0,  5 -- 
#  1,  6 --  2.

#       (   ).

print "    (   ,  Enter)\n";
print "     Enter,   \n";

#      '\n'.
while ( chomp( $symbol = <STDIN> ) )
{
  # E   Enter --  
  if ( $symbol =~ /^$/ )
  {
    last;
  }
  #       --  .
  elsif ( $symbol !~ /^[0-9]$/ )
  {
    print "    \n";
    next;
  }

  push( @operand1, $symbol );      #    .
}

#       (   ).

print "    (   ,  Enter)\n";
print "     Enter,   \n";

#      '\n'.
while ( chomp( $symbol = <STDIN> ) )
{
  # E   Enter --  
  if ( $symbol =~ /^$/ )
  {
    last;
  }
  #       --  .
  elsif ( $symbol !~ /^[0-9]$/ )
  {
    print "    \n";
    next;
  }

  push( @operand2, $symbol );      #    .
}

#    .
print "  = " . join( "", @operand1 ) . "\n";
print "  = " . join( "", @operand2 ) . "\n\n";

#    ,   .       
#    -- ,   .      ,
#    .
while ( $operand1[ 0 ] == 0 && scalar @operand1 > 1 )
{
  shift( @operand1 );
}

while ( $operand2[ 0 ] == 0 && scalar @operand2 > 1 )
{
  shift( @operand2 );
}

#   .
#     ,   -.  
#      .
@result = &{ $operations{ $operation } }( \@operand1, \@operand2 );

if ( $operation eq '-' )
{
  #  .   "".
  print " = " . $result[ 1 ] . join( "", @{ $result[ 0 ] } ) . "\n";
}
elsif ( $operation eq '/' )
{
  #  .
  print " = " . join( "", @{ $result[ 0 ] } ) . ", " .
        " = " . join( "", @{ $result[ 1 ] } ) . "\n";
}

exit( 0 );

# -----------------------------------------------------------------------------
# 
# -----------------------------------------------------------------------------
sub addition( $$ )
{
  print "    \n";
  return;
}

# -----------------------------------------------------------------------------
# 
# -----------------------------------------------------------------------------
sub division( $$ )
{
  my @dividend = @{ shift() };  # ,   
  my @divisor = @{ shift() };   # ,   

  my @result = ();              # ,   
  my @remainder = ();           # ,   
  my $i;                        #
  my $digit;                    #  
  my $length_diff;              #    
  my $which_is_bigger;          #     
  my $pos_in_dividend;          #      
  my @part_dividend;            #   () 
  my $product_ref;              #      
                                #     (ref -- reference)
  my @tmp;

  #   .
  print ":  " . join( "", @dividend ) . "\n";
  print ": " . join( "", @divisor ) . "\n";

  #    ,       
  #     ,     : 
  #   -- ,  -- .
  if ( scalar @divisor == 1 && $divisor[ 0 ] == 0 )
  {
    print "   \n";
    return ( [ 0 ], [ 0 ] );
  }
  
  #    .
  $which_is_bigger = compare_numbers( \@dividend, \@divisor );

  if ( $which_is_bigger == 1 )     #  
  {
    ;   #    (     ).
  }
  elsif ( $which_is_bigger == 2 )  #  
  {
    #   0 (        
    # ),      (    ).
    return ( [ 0 ], \@dividend );
  }
  else                             #  
  {
    #       .
    return ( [ 1 ], [ 0 ] );       #  -- 1,  -- 0
  }
  
  #      .     
  # ,   ()    . 
  #   --      ( , 
  #   ),     , . .  . 
  #        ,    .
  for ( $pos_in_dividend = 0; $pos_in_dividend <= $#dividend; 
        $pos_in_dividend++ )
  {
    #      @part_dividend.
    push( @part_dividend, $dividend[ $pos_in_dividend ] );

    #  ,      
    #    ,     
    #        .  
    #       0.  
    #   ,     ,  .  
    #      0,     
    # ,       , 
    #  ,     (    ).
    # : 10000 / 2.
    #
    # 10000 | 2
    # 10    |------ 
    # --     5000
    #  0 <--       @part_dividend  
    #             @part_dividend  
    #         0000 (.. ,       
    #         )
    if ( scalar @part_dividend == 1 && $part_dividend[ 0 ] == 0 )
    {
      push( @result, 0 );      #  0    .
      @part_dividend = ();     #  () .
      next;                    #        .
    }
    
    #     ,     ,
    #        .
    if ( compare_numbers( \@part_dividend, \@divisor ) == 2 )
    {
      #  0    .      
      #    (..       
      # ),   0   () .
      #        
      #  .
      push( @result, 0 );
      next;
    }
  
    #         
    #  .
    ( $digit, $product_ref ) = get_quotient_digit( \@part_dividend,
                                                   \@divisor );
    #     .
    push( @result, $digit );

    #         
    #     .
    @tmp = subtraction( \@part_dividend, $product_ref );
    @part_dividend = @{ $tmp[ 0 ] };

    #        
    #    ,       0.
    # : 121   3.     12 - 12 = 0,
    #      4.
    #      0      @tmp.
    #        0   , 
    #     .
    #           
    # ,    0   @part_dividend  . 
    #       0,      
    #  . 
    # :
    # 124 | 4
    # 12  |-----
    # --- | 31 
    #   4
    #   4
    #   --
    #   0
    if ( scalar @part_dividend == 1 && $part_dividend[ 0 ] == 0 &&
         $pos_in_dividend != $#dividend )
    {
      #     --   ($pos_in_dividend != 
      # $#dividend),   .
      @part_dividend = ();
    }
  }

  #    ,   .

  #    , ,   ,  
  # ()    .   
  #  ,  ...
  if ( scalar @part_dividend == 0 )
  {
    @remainder = ( 0 );  # ...       0
  }
  #     , ...
  elsif ( scalar @part_dividend == 1 && $part_dividend[ 0 ] == 0 )
  {
    @remainder = ( 0 );  # ...       0
  }
  else
  {
    @remainder = @part_dividend;    #     .
  }

  #        .  
  #   -- .  .
  shift( @result ) 
    while ( $result[ 0 ] == 0 );

  #       :   .
  return ( \@result, \@remainder );
}

# -----------------------------------------------------------------------------
# 
# -----------------------------------------------------------------------------
sub multiplication( $$ )
{
  print "    \n";
  return;
}

# -----------------------------------------------------------------------------
# 
# -----------------------------------------------------------------------------
sub subtraction( $$ )
{
  #         shift.
  #  shift         @_. 
  #      ,    @_ 
  #    .   
  #    ,       
  #    @{ ... }.
  my @minuend = @{ shift() };    # ,   
  my @subtrahend = @{ shift() }; # ,   

  my @result = ();             # ,   
  my $i;                       #
  my $digit;                   #  
  my $length_diff;             #    
  my $which_is_bigger;         #     
  my @tmp;
  my $sign = "";               #   
                               # (   ,
                               #   "-",     "")

  #    .
  $which_is_bigger = compare_numbers( \@minuend, \@subtrahend );

  if ( $which_is_bigger == 1 )     #  
  {
    ;   #    (     ).
  }
  elsif ( $which_is_bigger == 2 )  #  
  {
    #     .
    @tmp = @minuend;
    @minuend = @subtrahend;
    @subtrahend = @tmp;
    $sign = "-";                   #    ""
  }
  else                             #  
  {
    # [ 0 ] --     ,   
    return ( [ 0 ], $sign );
  }

  #     .
  $length_diff = scalar @minuend - scalar @subtrahend;

  #    ,    .
  for ( my $j = 0; $j < $length_diff; $j++ )
  {
    #      (  ).
    unshift( @subtrahend, 0 );
  }

  #   .
  print join( "", @minuend ) . "\n";
  print join( "", @subtrahend ) . "\n";

  #       .   
  #   .
  $i = $#minuend;

  #       
  while ( $i >= 0 )
  {
    #         ,
    #    --       
    #    .
    if ( $minuend[ $i ] >= $subtrahend[ $i ] )
    {
      # .  @result     . 
      #                   ,   
      #             ,   .
      $result[ $i ] = $minuend[ $i ] - $subtrahend[ $i ];

      #       , . .   
      #     ,     
      #      .
      $i--;
    }
    #        ,
    #      ,    ""
    #      .
    elsif ( $minuend[ $i - 1 ] > 0 )
    {
      #        10, ...
      $result[ $i ] = $minuend[ $i ] + 10 - $subtrahend[ $i ];

      # ...       1.
      $minuend[ $i - 1 ]--;

      $i--;     #    
    }
    #       , ...
    else
    {
      my $tmp_index = $i - 1;  #    

      # ...      ,    , 
      #   , ...
      while ( $minuend[ $tmp_index ] == 0 )
      {
        # ...           9.
        $minuend[ $tmp_index ] = 9;
        $tmp_index--;
      }

      #  ,     0.     1 ( 
      # ""  ).
      $minuend[ $tmp_index ]--;

      #      ,     .
      $result[ $i ] = $minuend[ $i ] + 10 - $subtrahend[ $i ];

      #    , . .        9,
      #    1  ,      .
      # $minuend[ $i - 1 ]--;

      $i--;    #    
    }
  }

  #       -,   
  # .
  shift( @result ) 
    while ( $result[ 0 ] == 0 && scalar @result > 1 );

  #         .
  return ( \@result, $sign );
}

# -----------------------------------------------------------------------------
#  
# -----------------------------------------------------------------------------

# -----------------------------------------------------------------------------
#   
# -----------------------------------------------------------------------------
sub compare_numbers( $$ )
{
  my @num1 = @{ shift() };         # ,    
  my @num2 = @{ shift() };         # ,    

  my $digits_num;                  #     (  )
  my $result;
  my $pos;                         #     (  )

  # !
  # ,   ()    .
  # ---------------------------------------------------------
  
  #     --  .  
  if ( scalar @num1 > scalar @num2 )
  {
    $result = 1;
  }
  #     --  .
  elsif ( scalar @num1 < scalar @num2 )
  {
    $result = 2;
  }
  else  #   
  {
    $pos = 0;
    $digits_num = scalar @num1;  #      

    #        ,    .
    #      .
    while ( $pos < $digits_num && $num1[ $pos ] == $num2[ $pos ] )
    {
      #    ,       , ,
      #    , ...
      $pos++;   # ...     
    }

    #    ,    ,   
    # ,  , ,  .
    if ( $pos == $digits_num )
    {
      $result = 0;
    }
    else  # $pos < $digits_num, . .      $pos
    {
      if ( $num1[ $pos ] > $num2[ $pos ] )
      {
        $result = 1;  #    .
      }
      else
      {
        $result = 2;  #    .
      }
    }
  }

  return $result;
}

# -----------------------------------------------------------------------------
#    
# -----------------------------------------------------------------------------
sub get_quotient_digit( $$ )
{
  my @part_dividend = @{ shift() }; # ,   
                                    # 
  my @divisor = @{ shift() };       # ,   

  my $multiplier;                   #    ()
  my @product = ();                 #     
  my $two_digits_product;           #     
                                    #  
  my $additional_digit = 0;         #   ,  
                                    # ,   $two_digits_product
                                    #   
  my $pos;                          #    
  
  #     .    9. 
  #   .      ,
  #   8  . .       
  #   --  !
  for ( $multiplier = 9; $multiplier >= 1; $multiplier-- )
  {
    #      ,     .
    for ( $pos = $#divisor; $pos >= 0; $pos-- )
    {
      #   -     
      # ,   "  ",     
      #  . 
      $two_digits_product = $multiplier * $divisor[ $pos ] + $additional_digit;

      #         
      #  10.      10,  .
      push( @product, $two_digits_product % 10 );

      #        10, ...
      if ( $two_digits_product >= 10 )
      {
        # ...    ,      " ".
        $additional_digit = substr( sprintf( "%2d", $two_digits_product ),
                                    0, 1 );
      }
      #    ...
      else
      {
        # ...    " ",     
        #   .
        $additional_digit = 0;
      }
    }

    #    " "       
    #  , ...
    if ( $additional_digit > 0 )
    {
      # ...       . 
      #   --       .
      push( @product, $additional_digit );
    }

    #       ,   
    # ,       ,   
    #       .
    @product = reverse( @product );
    
    #         
    # ,   .
    last if ( compare_numbers( \@part_dividend, \@product ) == 1 || 
              compare_numbers( \@part_dividend, \@product ) == 0 );

    #    -  .
    @product = ();
    $additional_digit = 0;
  }

  #     :   
  #          .
  return ( $multiplier, \@product );
}
