#!/usr/bin/perl -w

use strict;

my( $student, $avg_mark ); # . . .   

#   .
while ( <STDIN> )
{
  #    .
  chomp;

  #      .
  #      ,
  #      .
  ( $student, $avg_mark ) = calculate( $_ );

  print "$student $avg_mark\n";
}

exit( 0 );

sub calculate
{
  my $line = shift;  #    

  my @tmp;           #  
  my $stud;          # , , 
  my $total = 0;     #   

  #  split   $line  ,
  #        .
  @tmp = split( /\s+/, $line );

  #    0, 1  2 -- , , .
  # $#tmp --    .
  # 3 .. $#tmp --      3- 
  #  .
  foreach my $mark ( @tmp[ 3 .. $#tmp ] )
  {
    # print "\$mark = $mark\n";  #  
    $total += $mark;             #  
  }

  $stud = "$tmp[ 0 ] $tmp[ 1 ] $tmp[ 2 ]";

  #     .
  #   ,  
  #  .
  # scalar( @tmp ) - 3 --   .
  return ( $stud, $total / ( scalar( @tmp ) - 3 ) );
}
