#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
# Группа программ: "Использование Unicode в Perl"
# Программа: использование Unicode в исходном тексте скрипта в строковых 
#            литералах (значения переменных)
# Автор:     Моргунов Е. П.
# Дата:      18.12.2013
# Версия:    0.1
# -----------------------------------------------------------------------------

# эта строка означает строгую проверку синтаксиса исходного текста программы
use strict;

# эта директива означает, что ИСХОДНЫЙ ТЕКСТ скрипта представлен в Unicode
use utf8;

# При выводе данных на стандартный вывод также назначаем кодировку UTF-8. Если
# эту строку закомментировать, то будет выведено предупреждение "Wide character
# in print ..."
binmode STDOUT, ':encoding(UTF-8)'; # можно сделать и так (хотя эти два метода 
                                    # НЕ ТОЖДЕСТВЕННЫ): binmode STDOUT, ':utf8';
my $string = "Россия";

print "$string\n";

exit 0;
