#!/usr/bin/perl -w
# ----------------------------------------------------------------------------
# ,     Perl
# ----------------------------------------------------------------------------

#       ,
#     @EXPORT  Math::Geometry
# (      circle_len  circle_area)
use Math::Geometry;

#      ,
#     @EXPORT_OK  Math::Geometry
# .        
#                 ,  .
use Math::Geometry qw( square_perim );

#    #define
use constant  PRINT_FORMULA => 1;

use strict;

my $rad;
my $side;

print "  () Math::Geometry\n\n";

print "  : ";
$rad = <STDIN>;
printf "\n%f\n", $rad;
printf " : %f\n", circle_len( $rad, PRINT_FORMULA );
printf " : %f\n", circle_area( $rad, PRINT_FORMULA );

print "\n   : ";
$side = <STDIN>;
printf "\n%f\n", $side;
printf " : %f\n", square_perim( $side, PRINT_FORMULA );

#   square_area      @EXPORT, 
#    @EXPORT_OK  () Math::Geometry,
#       ,
#    ()
printf " : %f\n",
       Math::Geometry::square_area( $side, PRINT_FORMULA );

print "\n  Math::Geometry\n";
# .  ,    priv_var ,
#                  .
print "priv_var = " . $Math::Geometry::priv_var . "\n";
print "Var1 = " . $Math::Geometry::Var1 . "\n";
print "stuff = " . $Math::Geometry::stuff . "\n";

exit 0;
