<?php
/*
  : "  "
  :        
  :   . . 
  :    30.11.2017
  :  0.1
*/

/*
          
     disciplines.
*/
function display_discipline_form( $discipline_info )
{
  // : $discipline_info --     .
  //       ,   
  //    ,     .

  include 'head.php';

  //     ,   
  //   JavaScript.
  echo "<script src=\"disciplines.js\"></script>\n";

  //   --  ,    
  //  $discipline_info.
  if ( isset( $discipline_info ) )
  {
    $script_name = $_SERVER[ 'SCRIPT_NAME' ] . "?operation=update";
    $operation = 'update_discipline';
    $discipline_code = $discipline_info[ 'discipline_code' ];
    $discipline_name = $discipline_info[ 'discipline_name' ];
  }
  else  //   
  {
    $script_name = $_SERVER[ 'SCRIPT_NAME' ] . "?operation=insert";
    $operation = 'add_discipline';
    $discipline_code = '';
    $discipline_name = '';
  }

  //  action   ,    ,
  //    .  onsubmit    
  //   .
  //   (type="hidden")   name="current_discipline_code"
  //   ,      " 
  // "         
  //  .
  echo <<<END
<form id="discipline_form" action="$script_name" method="post"
      onsubmit="return check_discipline_form()">
  <fieldset id="disciplines">
    <legend> </legend>
    <label for="d_code">  </label>
    <input id="d_code" type="text" name="discipline_code" size="4"
     maxlength="3" value="$discipline_code"
     title="      1  3" />

    <input type="hidden" name="current_discipline_code"
     value="$discipline_code" />

    <label for="d_name">  </label>
    <input id="d_name" type="text" name="discipline_name" size="60"
     maxlength="100" value="$discipline_name" />

    <input class="submit" type="submit" name="$operation" value="" />

    <p id="error"></p>
  </fieldset>
</form>

END;

  echo "<a href=\"" . $_SERVER[ 'SCRIPT_NAME' ] . 
       "?operation=list\" target=\"_self\">" .
       "  </a><br />\n";

  include 'foot.php';
}

/*
       disciplines.
*/
function display_disciplines_list( $disciplines_list, $select_flag )
{
  // : $disciplines_list --     ;
  //            $select_flag --      
  //                                .

  include 'head.php';

  //     ,   
  //   JavaScript.
  echo "<script src=\"disciplines.js\"></script>\n";
  echo "<script src=\"university.js\"></script>\n";

  echo "<h2> </h2>\n";

  /*        . */
  if ( ! isset( $select_flag ) )
    echo "<a href=\"" . $_SERVER[ 'SCRIPT_NAME' ] . 
         "?operation=insert\" target=\"_self\"> </a><br />\n";

  //     .
  echo "<table id=\"disciplines_table\">\n";

  //  .
  echo "  <tr>\n";
  echo "    <th> </th>\n" ;
  echo "    <th> </th>\n" ;

  if ( isset( $select_flag ) )
    echo "    <th>&nbsp;</th>\n" ;  //  
  else
  {
    echo "    <th>&nbsp;</th>\n" ;  //  
    echo "    <th>&nbsp;</th>\n" ;  //  
  }
  echo "  </tr>\n";

  //        :
  // row0, row1  . .
  $row = 0;

  //       .  
  //  -,    :
  // $disc[ 'discipline_name' ].
  foreach ( $disciplines_list as $disc )
  {
    echo "<tr id=\"row" . $row . "\">\n";

    echo "<td class=\"center\">" . $disc[ 'discipline_code' ] . "</td>\n";
    echo "<td>" . $disc[ 'discipline_name' ] . "</td>\n";

    //           ...
    if ( isset( $select_flag ) )
    {
      echo "<td><a href=\"javascipt:void( 0 )\" " .
           "onclick=\"assign_values( " . $disc[ 'discipline_code' ] .
           ", '" . $disc[ 'discipline_name' ] . "' )\"></a></td>\n";
    }
    else
    {
      //  javascript:void( 0 )   , 
      //       , 
      //   onclick,      .
      //  $_SERVER[ 'SCRIPT_NAME' ]   , 
      //    HTML-.     
      //    .     
      //  GET.   :     .
      //    "&".
      echo "<td><a href=\"javascript:void( 0 )\" " .
           "onclick=\"confirm( ' ?' ) && delete_discipline( '" .
           $_SERVER[ 'SCRIPT_NAME' ] . "', " .  $disc[ 'discipline_code' ] .
           ", 'row" . $row . "' )\"" .
           " target=\"_self\"></a></td>\n";

      echo "<td><a href=\"" . $_SERVER[ 'SCRIPT_NAME' ] . 
           "?operation=update&discipline_code=" . $disc[ 'discipline_code' ] .
           "\" target=\"_self\"></a></td>\n";
    }
    
    echo "</tr>\n";

    $row++;
  }

  echo "</table>\n";

  include 'foot.php';  
  return 0;
}

/*
         disciplines.
*/
function inform_inserted_discipline( $rec_num )
{
  // : $rec_num --    (1  0).

  //     ,    
  //   HTML-.
  include 'head.php';

  if ( $rec_num == 1 )
    echo "<p class=\"messages\"> </p>\n";
  elseif ( $rec_num == 0 )
    echo "<p class=\"messages\">  </p>\n";

  echo "<a href=\"" . $_SERVER[ 'SCRIPT_NAME' ] . 
       "?operation=insert\" target=\"_self\"> </a><br />\n";

  echo "<a href=\"" . $_SERVER[ 'SCRIPT_NAME' ] . 
       "?operation=list\" target=\"_self\">" .
       "  </a><br />\n";

  //     ,    
  //   HTML-.
  include 'foot.php';
}

/*
        disciplines.
*/
function inform_updated_discipline( $rec_num )
{
  // : $rec_num --    (1  0).

  include 'head.php';

  if ( $rec_num == 1 )
    echo "<p class=\"messages\"> </p>\n";
  elseif ( $rec_num == 0 )
    echo "<p class=\"messages\">  </p>\n";

  echo "<a href=\"" . $_SERVER[ 'SCRIPT_NAME' ] . 
       "?operation=insert\" target=\"_self\"> </a><br />\n";

  echo "<a href=\"" . $_SERVER[ 'SCRIPT_NAME' ] . 
       "?operation=list\" target=\"_self\">" .
       "  </a><br />\n";

  include 'foot.php';
}

?>
