<?php
/*
  : "  "
  :  " " ( )
  :   . . 
  :    30.11.2017
  :  0.1
*/

/*
          
     progress.
*/
function display_exam_form( $record_book, $name, $exam_info )
{
  // : $record_book --   ;
  //            $name -- . . . ;
  //            $exam_info --     .
  //                  ,  
  //                ,    
  //             .

  include 'head.php';

  //     ,   
  //   JavaScript.
  echo "<script src=\"progress.js\"></script>\n";

  //   --  ,    
  //  $exam_info.
  if ( isset( $exam_info ) )
  {
    $script_name = $_SERVER[ 'SCRIPT_NAME' ] . "?operation=update";
    $operation = 'update_exam';
    $acad_year = $exam_info[ 'acad_year' ];
    $term = $exam_info[ 'term' ];
    $discipline_code = $exam_info[ 'discipline_code' ];
    $discipline_name = $exam_info[ 'discipline_name' ];
    $mark = $exam_info[ 'mark' ];
  }
  else  //   
  {
    $script_name = $_SERVER[ 'SCRIPT_NAME' ] . "?operation=insert";
    $operation = 'add_exam';
    $acad_year = '2017/2018'; //  
    $term = '1';              //  
    $discipline_code = '';
    $discipline_name = '';
    $mark = '5';              //  
  }

  //  action   ,    ,
  //    .  onsubmit    
  //   .
  //   (type="hidden")   name="current_record_book"  .
  //   ,      " 
  // ", " "  .        
  //   .
  //   (type="hidden")   name="name" --  . . .
  // .    ,   
  //   inform_inserted_exam.
  //          Submit.
  echo <<<END
<form id="exam_form" action="$script_name" method="post"
      onsubmit="return check_exam_form()">
  <fieldset id="personal">
    <legend> &nbsp;&nbsp;$name </legend>
    <label for="r_book">  </label>
    <input id="r_book" type="text" name="record_book" size="6"
     maxlength="5" value="$record_book" readonly="readonly" />

    <input type="hidden" name="current_record_book" value="$record_book" />
    <input type="hidden" name="current_acad_year" value="$acad_year" />
    <input type="hidden" name="current_term" value="$term" />
    <input type="hidden" name="current_discipline_code"
     value="$discipline_code" />

    <label for="a_year"> </label>
    <select id="a_year" name="acad_year"> 
END;
  foreach ( array( '2017/2018', '2016/2017', '2015/2016' ) as $ay )
  {
    echo "      <option value=\"$ay\"";
    if ( $acad_year == $ay )
      echo " selected=\"selected\"";

    echo ">$ay</option>\n";
  }
  echo "   </select>\n";

  echo "   <label for=\"term\"></label>\n";

  foreach ( array( '1', '2' ) as $t )
  {

    echo "      <input type=\"radio\" id=\"term\" name=\"term\" value=\"$t\"";
    if ( $term == $t )
      echo " checked=\"checked\"";

    echo "> $t\n";
  }

  //      style  <input>  ,
  //           
  // .
  echo <<<END
    <label for="d_code"> </label>
    <input id="d_code" type="text" name="discipline_code" size="3"
     maxlength="4" value="$discipline_code" style="display: inline" />
    <a href="javascript:void( 0 )" onclick="select_discipline()">
      </a>

    <label for="d_name"> </label>
    <textarea id="d_name" name="discipline_name" rows="3" cols="60"
     readonly="readonly"> $discipline_name </textarea>

    <label for="mark"></label>
    <select id="mark" name="mark"> 
END;

  foreach ( array( 5 => '',
                   4 => '',
                   3 =>  '' ) as $digit => $word )
  {
    echo "      <option value=\"$digit\"";
    if ( $mark == $digit )
      echo " selected=\"selected\"";

    echo ">$word</option>\n";
  }
  echo <<<END
    </select>

    <input type="hidden" name="name" value="$name" />
    <input class="submit" type="submit" name="$operation" value="" />

    <p id="error"></p>
  </fieldset>
</form>
END;

  echo "<a href=\"" . $_SERVER[ 'SCRIPT_NAME' ] . 
       "?operation=list&record_book=$record_book&name=$name\" " .
       "target=\"_self\">  </a><br />\n";

  include 'foot.php';
}

/*
       progress    
  .
*/
function display_exams_list( $record_book, $name, $exams_list )
{
  // : $record_book --   ;
  //            $name -- . . . ;
  //            $exams_list --     
  //                            .

  include 'head.php';

  //     ,   
  //   JavaScript.
  echo "<script src=\"progress.js\"></script>\n";
  echo "<script src=\"university.js\"></script>\n";

  echo "<h2>  </h2>\n";

  echo "<h3>$record_book $name</h3>\n";

  echo "<a href=\"" . $_SERVER[ 'SCRIPT_NAME' ] . 
       "?operation=insert&record_book=$record_book&name=$name\" " .
       "target=\"_self\"> </a><br />\n";

  //     .
  echo "<table id=\"exams_table\">\n";

  //  .
  echo "<tr>\n";
  // echo "<th>  </th>\n" ;
  echo "<th> </th>\n" ;
  echo "<th></th>\n" ;
  echo "<th></th>\n" ;
  echo "<th></th>\n" ;
  echo "<th>&nbsp;</th>\n" ;  //  
  echo "<th>&nbsp;</th>\n" ;  //  
  echo "</tr>\n";

  //        :
  // row0, row1  . .
  $row = 0;

  //       .  
  //  -,    : $stud[ 'name' ].
  foreach ( $exams_list as $exam )
  {
    echo "<tr id=\"row" . $row . "\">\n";

    echo "<td class=\"center\">" . $exam[ 'acad_year' ] . "</td>\n";
    echo "<td class=\"center\">" . $exam[ 'term' ] . "</td>\n";
    echo "<td>" . $exam[ 'discipline_name' ] . "</td>\n";
    echo "<td class=\"center\">" . $exam[ 'mark' ] . "</td>\n";

    //  javascript:void( 0 )   , 
    //       , 
    //   onclick,      .
    //  $_SERVER[ 'SCRIPT_NAME' ]   , 
    //    HTML-.     
    //    .     
    //  GET.   :     .
    //    "&".
    echo "<td><a href=\"javascript:void( 0 );\" " .
         "onclick=\"confirm( ' ?' ) && delete_exam( '" .
         $_SERVER[ 'SCRIPT_NAME' ] . "', " . $exam[ 'record_book' ] .
         ", '" . $exam[ 'acad_year' ] . "', " .  $exam[ 'term' ] .
         ", " . $exam[ 'discipline_code' ] . ", 'row" . $row . "' )\"" .
         " target=\"_self\"></a></td>\n";

    //  :   (update)    .
    echo "<td><a href=\"" . $_SERVER[ 'SCRIPT_NAME' ] . 
         "?operation=update&record_book=" . $exam[ 'record_book' ] .
         "&acad_year=" . $exam[ 'acad_year' ] . "&term=" .  $exam[ 'term' ] .
         "&discipline_code=" . $exam[ 'discipline_code' ] .  "&name=$name" .
         "\" target=\"_self\"></a></td>\n";

    echo "</tr>\n";

    $row++;
  }

  echo "</table>\n";

  include 'foot.php';  
  return 0;
}

/*
         progress.
*/
function inform_inserted_exam( $rec_num )
{
  // : $rec_num --    (1  0).

  //     ,    
  //   HTML-.
  include 'head.php';

  echo "<h3>" . $_POST[ 'record_book' ] . " " . $_POST[ 'name' ] . "</h3>\n";

  if ( $rec_num == 1 )
    echo "<p class=\"messages\"> </p>\n";
  elseif ( $rec_num == 0 )
    echo "<p class=\"messages\">  </p>\n";

  echo "<a href=\"" . $_SERVER[ 'SCRIPT_NAME' ] . 
       "?operation=insert&record_book=" . $_POST[ 'record_book' ] .
       "&name=" . $_POST[ 'name' ] . "\" " .
       "target=\"_self\"> </a><br />\n";

  echo "<a href=\"" . $_SERVER[ 'SCRIPT_NAME' ] . 
       "?operation=list&record_book=" . $_POST[ 'record_book' ] .
       "&name=" . $_POST[ 'name' ] . "\" " .
       "target=\"_self\">  </a><br />\n";

  //     ,    
  //   HTML-.
  include 'foot.php';
}

/*
        progress.
*/
function inform_updated_exam( $rec_num )
{
  // : $rec_num --    (1  0).

  include 'head.php';

  echo "<h3>" . $_POST[ 'record_book' ] . " " . $_POST[ 'name' ] . "</h3>\n";

  if ( $rec_num == 1 )
    echo "<p class=\"messages\"> </p>\n";
  elseif ( $rec_num == 0 )
    echo "<p class=\"messages\">  </p>\n";

  echo "<a href=\"" . $_SERVER[ 'SCRIPT_NAME' ] . 
       "?operation=insert&record_book=" . $_POST[ 'record_book' ] .
       "&name=" . $_POST[ 'name' ] . "\" " .
       "target=\"_self\"> </a><br />\n";

  echo "<a href=\"" . $_SERVER[ 'SCRIPT_NAME' ] . 
       "?operation=list&record_book=" . $_POST[ 'record_book' ] .
       "&name=" . $_POST[ 'name' ] . "\" " .
       "target=\"_self\">  </a><br />\n";

  include 'foot.php';
}

?>
