<?php
/*
  : "  "
  :        
  :   . . 
  :    30.11.2017
  :  0.1
*/

/*
          
     students.
*/
function display_student_form( $student_info )
{
  // : $student_info --     .
  //       ,   
  //    ,     .

  include 'head.php';

  //     ,   
  //   JavaScript.
  echo "<script src=\"students.js\"></script>\n";

  //   --  ,    
  //  $student_info.
  if ( isset( $student_info ) )
  {
    $script_name = $_SERVER[ 'SCRIPT_NAME' ] . "?operation=update";
    $operation = 'update_student';
    $record_book = $student_info[ 'record_book' ];
    $name = $student_info[ 'name' ];
    $psp_ser = $student_info[ 'psp_ser' ];
    $psp_num = $student_info[ 'psp_num' ];
  }
  else  //   
  {
    $script_name = $_SERVER[ 'SCRIPT_NAME' ] . "?operation=insert";
    $operation = 'add_student';
    $record_book = '';
    $name = '';
    $psp_ser = '';
    $psp_num = '';
  }

  //  action   ,    ,
  //    .  onsubmit    
  //   .
  //   (type="hidden")   name="current_record_book"
  //   ,      " 
  // "           .
  echo <<<END
<form id="student_form" action="$script_name" method="post"
      onsubmit="return check_student_form()">
  <fieldset id="personal">
    <legend> </legend>
    <label for="r_book">  </label>
    <input id="r_book" type="text" name="record_book" size="6"
     maxlength="5" value="$record_book" title="     5" />

    <input type="hidden" name="current_record_book" value="$record_book" />

    <label for="f_name">, , </label>
    <input id="f_name" type="text" name="name" size="40" maxlength="50"
     value="$name" />

    <label for="p_ser"> </label>
    <input id="p_ser" type="text" name="psp_ser" size="5" maxlength="4"
     value="$psp_ser" title="      4" />

    <label for="p_num"> </label>
    <input id="p_num" type="text" name="psp_num" size="7" maxlength="6"
     value="$psp_num" title="      6" />

    <input class="submit" type="submit" name="$operation" value="" />

    <p id="error"></p>
  </fieldset>
</form>

END;

  echo "<a href=\"" . $_SERVER[ 'SCRIPT_NAME' ] . 
       "?operation=list\" target=\"_self\">  </a>\n";

  include 'foot.php';
}

/*
       students.
*/
function display_students_list( $students_list )
{
  // : $students_list --     .

  include 'head.php';

  //     ,   
  //   JavaScript.
  echo "<script src=\"students.js\"></script>\n";
  echo "<script src=\"university.js\"></script>\n";

  echo "<h2>  </h2>\n";

  echo "<a href=\"" . $_SERVER[ 'SCRIPT_NAME' ] . 
       "?operation=insert\" target=\"_self\"> </a><br />\n";

  //     .
  echo "<table id=\"students_table\">\n";

  //  .
  echo "  <tr>\n";
  echo "    <th>  </th>\n" ;
  echo "    <th>, , </th>\n" ;
  echo "    <th> </th>\n" ;
  echo "    <th> </th>\n" ;
  echo "    <th>&nbsp;</th>\n" ;  //  
  echo "    <th>&nbsp;</th>\n" ;  //  
  echo "    <th>&nbsp;</th>\n" ;  //  
  echo "  </tr>\n";

  //        :
  // row0, row1  . .
  $row = 0;

  //       .  
  //  -,    : $stud[ 'name' ].
  foreach ( $students_list as $stud )
  {
    echo "<tr id=\"row" . $row . "\">\n";

    echo "<td class=\"center\">" . $stud[ 'record_book' ] . "</td>\n";
    echo "<td>" . $stud[ 'name' ] . "</td>\n";
    echo "<td class=\"center\">" . $stud[ 'psp_ser' ] . "</td>\n";
    echo "<td class=\"center\">" . $stud[ 'psp_num' ] . "</td>\n";

    //  javascript:void( 0 )   , 
    //       , 
    //   onclick,      .
    //  $_SERVER[ 'SCRIPT_NAME' ]   , 
    //    HTML-.     
    //    .     
    //  GET.   :     .
    //    "&".
    echo "<td><a href=\"javascript:void( 0 );\" " .
         "onclick=\"confirm( ' ?' ) && delete_student( '" .
         $_SERVER[ 'SCRIPT_NAME' ] . "', " .  $stud[ 'record_book' ] .
         ", 'row" . $row . "' )\"" .
         " target=\"_self\"></a></td>\n";

    //  :   (update)    .
    echo "<td><a href=\"" . $_SERVER[ 'SCRIPT_NAME' ] . 
         "?operation=update&record_book=" . $stud[ 'record_book' ] .
         "\" target=\"_self\"></a></td>\n";

    //  :   (progress)    .
    echo "<td><a href=\"progress.php" . 
         "?operation=progress&record_book=" . $stud[ 'record_book' ] .
         "&name=" . $stud[ 'name' ] .
         "\" target=\"_blank\"> </a></td>\n";

    echo "</tr>\n";

    $row++;
  }

  echo "</table>\n";

  include 'foot.php';  
  return 0;
}

/*
         students.
*/
function inform_inserted_student( $rec_num )
{
  // : $rec_num --    (1  0).

  //     ,    
  //   HTML-.
  include 'head.php';

  if ( $rec_num == 1 )
    echo "<p class=\"messages\"> </p>\n";
  elseif ( $rec_num == 0 )
    echo "<p class=\"messages\">  </p>\n";

  echo "<a href=\"" . $_SERVER[ 'SCRIPT_NAME' ] . 
       "?operation=insert\" target=\"_self\"> </a><br />\n";

  echo "<a href=\"" . $_SERVER[ 'SCRIPT_NAME' ] . 
       "?operation=list\" target=\"_self\">  </a><br />\n";

  //     ,    
  //   HTML-.
  include 'foot.php';
}

/*
        students.
*/
function inform_updated_student( $rec_num )
{
  // : $rec_num --    (1  0).

  include 'head.php';

  if ( $rec_num == 1 )
    echo "<p class=\"messages\"> </p>\n";
  elseif ( $rec_num == 0 )
    echo "<p class=\"messages\">  </p>\n";

  echo "<a href=\"" . $_SERVER[ 'SCRIPT_NAME' ] . 
       "?operation=insert\" target=\"_self\"> </a><br />\n";

  echo "<a href=\"" . $_SERVER[ 'SCRIPT_NAME' ] . 
       "?operation=list\" target=\"_self\">  </a><br />\n";

  include 'foot.php';
}

?>
